import { MerchantConfig } from "./MerchantConfig.js";
import fetch, { Response } from "node-fetch";
export class HttpClient {
    _config;
    constructor(config) {
        this._config = config;
    }
    execute(uri, json) {
        const headers = {
            'Content-Type': 'application/x-www-form-urlencoded',
            'User-Agent': MerchantConfig.userAgent
        };
        const controller = new AbortController();
        setTimeout(() => {
            controller.abort();
        }, this._config.timeout * 1000);
        const options = {
            method: 'post',
            headers: headers,
            body: encodeURIComponent(json),
            signal: controller.signal
        };
        return fetch(uri, options)
            .then(res => res.ok ? res : Promise.reject(res));
    }
}
//# sourceMappingURL=HttpClient.js.map